"""py2ch 2ch-Viewer DOLIB.
"""
#
# Copyright (c) 2005 Satoshi Fukutomi <fuktommy@inter7.jp>
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#

import re
import os
import urllib

import config

sidfile = os.path.join(config.cachedir, "viewer.txt")
ua = config.agent
sid = ua

urllib.URLopener.version = config.version
class DolibURLopener(urllib.FancyURLopener):
    def __init__(self, *args):
        self.version = "DOLIB/1.00"
        urllib.FancyURLopener.__init__(self, *args)
        self.addheader("X-2ch-UA", config.version)
        urllib.FancyURLopener.__init__(self, *args)
        self.proxies = []

def online():
    return os.path.isfile(sidfile)

def load():
    global ua
    global sid
    f = file(sidfile)
    ua = f.readline().strip()
    sid = f.readline().strip()

def login():
    try:
        f = file(config.viewer_pass)
        account = f.readline().strip()
        passwd = f.readline().strip()
        f.close()
        data = "%s=%s&%s=%s" % ("ID", account, "PW", passwd)
        #data = urllib.urlencode((("ID", account),
        #                         ("PW", passwd)))
        urlopener = DolibURLopener()
        f = urlopener.open("https://2chv.tora3.net/futen.cgi", data)
        content = f.read()
        if not content.startswith("SESSION-ID="):
            return False
        found = re.search(r"SESSION-ID=([^:]+):(.+)", content)
        if not found:
            return False
        ua = found.group(1)
        sid = "%s:%s" % (found.group(1), found.group(2))
        if ua == "ERROR":
            return False
        f = file(sidfile, "wb")
        f.write(ua + "\n")
        f.write(sid + "\n")
        f.close()
        return True
    except IOError:
        return False

def logout():
    try:
        os.remove(sidfile)
        return True
    except OSError:
        return False
