"""py2ch Post Interface.
"""
#
# Copyright (c) 2005 Satoshi Fukutomi <fuktommy@inter7.jp>
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#

import re
import sys
import urllib

from monazilla import posturl
import dolib
from dat import Cookie

def post_article(urlstr, form):
    buf = []
    for key in ("FROM", "mail", "MESSAGE", "host", "bbs", "key", "time"):
        val = form.getfirst(key, "")
        if val:
            buf.append((key, val))
    host = form.getfirst("host")
    bbs = form.getfirst("bbs")
    key = form.getfirst("key")
    if dolib.online():
        buf.append(("sid", dolib.sid))
    data = urllib.urlencode(buf)
    addheader = [("Referer", "http://%s/%s/index2.html" % (host, bbs))]
    cookie = Cookie()
    if "PON" in cookie:
        addheader.append(("Cookie", "PON=%s;" % cookie["PON"]))
    header, response = posturl("http://%s/test/bbs.cgi" % host,
                               data,
                               addheader)
    cookies = header.getheaders("Set-Cookie")
    for i in cookies:
        found = re.search(r"PON=([^;]+)", i)
        if found:
            pon = found.group(1)
            cookie["PON"] = pon
            cookie.sync()
            break
    print "Content-Type: text/html; charset=Shift_JIS"
    print
    for line in response:
        line = re.sub(r"<META[^<>]*refresh[^<>]*>", "", line)
        print line
